#include <def21161.h>

#define N 256

.section/dm seg_sram;
.var destination[N];

.section/dm seg_dmda;
.var sourceHost[N];
.var hostDMA_tcb[8] = 0,0,0,0,hostDMA_tcb + 7,N,1,sourceHost;//set PCI bit in CP bit 17;
//.var hostDMA_tcb[8] = 0,0,0,0,0,N,1,sourceHost;//set PCI bit in CP bit 17;

.var mem_count = 0;
.var host_count = 0;

.section/pm seg_rth;

//EMUI:
	nop;
	nop;
	nop;
	nop;
	
//RSTI:
	nop;
	jump start;
	nop;
	nop;
	
.section/pm seg_epb;

//EPB0I:
	nop;
	rti;
	nop;
	nop;
	
//EPB1I:
	nop;
	jump host_isr;
	nop;
	nop;
	
//EPB2I:
	nop;
	nop;
	nop;
	nop;
		
//EPB3I:
	nop;
	nop;
	nop;
	nop;	
	
.section/pm seg_pmco;
start:
	r0 = 0x1000;
	dm(SDRDIV) = r0;
	
	r0 = 0x02214231;
	dm(SDCTL) = r0;
	
	r0 = 0x018c0142;
	dm(EPCON) = r0;	
	
	bit set mode2 FLG2O;
	
	ustat1 = dm(IOFLAG);
	bit set ustat1 FLG5O;
	dm(IOFLAG) = ustat1;
	
	bit clr ustat1 FLG5;
	dm(IOFLAG) = ustat1;
	
	bit clr flags FLG2;
	
	i1 = sourceHost;
	m0 = 1;
	l1 = 0;
	l0 = 0;
	r0 = 0x0;
	
	lcntr = N, do _init until lce;
	r2 = lshift r0 by 10;
	dm(i1,m0) = r2;
_init: r0 = r0 + 1;	

	bit set imask EP0I | EP1I;
	bit set mode1 IRPTEN;
	
	ustat1 = TRAN | CHEN | DEN | INT32 | PMODE4;
	dm(DMAC11) = ustat1;
	
	r0 = hostDMA_tcb;
	r1 = 7;
	r0 = r0 + r1;

	dm(CP11) = r0;
	
	i0 = 0x120008;
	m0 = 0;
	r0 = 2;
	
	dm(i0,m0) = r0;

loophere:
	jump loophere;	

	
host_isr:
	r0 = dm(host_count);
	r0 = r0 + 1;
	dm(host_count) = r0;
	rti;
	
